/* AnruferMon (C) by Carsten Arnold, Version 0.71 */

call RxFuncAdd SysLoadFuncs, RexxUtil, SysLoadFuncs
call SysLoadFuncs

call RxFuncAdd 'DbRxLoadFuncs', 'CaTable', 'DbRxLoadFuncs' 
call DbRxLoadFuncs

rc = RxFuncAdd( 'ErxLoadFuncs', 'EClient', 'ErxLoadFuncs' )
say rc
rc = ErxLoadFuncs()
say rc

parse arg a

NoNum = 0
ExpAll = 0

if length( a )==0 then
do 
   'mode co60,10'  /* kleines Fenster */
   do i=1 to 60
      say '' 
   end /* do */
end /* do */


LastHook = ''

KCfgPipeName = 5
KCfgPassword = 9
Pipe = '\\arnold\pipe\EuraPM2'
Pipe = '127.0.0.1'
Pipe = '\\server09\pipe\EuraPM2'
Pipe = '\pipe\EuraPM2'
rc = ErxQueryGlobName( KCfgPipeName, 'Pipe' )
rc = ErxQueryGlobName( KCfgPassword, 'password' )
if rc>0 then password = ''

if password=='' then Aut = 0
                else Aut = 1

rc = ErxOpen( Pipe, 'h', 'x30', Aut, 'RexxClient "Anrufer-Monitor"', password )

if rc>0 then
do 
   say ErxGetErrorText( rc ) 'bei ErxOpen auf 'pipe
   call SysSleep 2
   exit rc
end /* do */
say 'Eingeloggt auf' pipe

Count = 0

KCfgPrefixName  = 0
KCfgRnrName     = 1

call ErxQueryGlobData KCfgRnrName, 'RnrName'
call ErxQueryGlobData KCfgPrefixName, 'PrefName'

rc = DbRxOpen( RnrName, 'hTabRnr' )
rc = DbRxOpen( PrefName, 'hTabPref' )
rc = DbRxAllocEdit( hTabRnr, 'hEditRnr' )
rc = DbRxAllocEdit( hTabPref, 'hEditPref' )

do forever
   rc = ErxRead( h, 'pANum', 'Nr', 'pFlags', 'Grp', 'Elem', 'Data' )
   if rc>0 & rc<>640 & rc<>1000 then leave
   if rc>0 then say rc

   if Grp='0A' & Elem='06' then
   do
      DateTime = format( Count, 6 ) Date('O') time()
      Count = Count + 1

      Line = parsedata( Data )
      if pos( '<CnPN(6C)', line )==1 then 
      do 
         Num = subword( Line, 3 )
         Num = strip( Num, 'b', '>' )
         rc = DbRxSetArray( hEditRnr, 0, Num )
         rc = DbRxFindRec( hEditRnr )
         if rc==0 then rc = DbRxGetArray( hEditRnr, 1, 'Name' )
         else Name = 'unbekannt'

         pref = Num
         do while length( pref )>0
            rc = DbRxSetArray( hEditPref, 0, pref )
            rc = DbRxFindRec( hEditPref )
            if rc>0 then pref = substr( pref, 1, length( pref )-1 )
            else leave
         end 
         if length( pref )>0 then 
         do 
            rc = DbRxGetArray( hEditPref, 1, 'Ort' )
            Ort = '  aus' pref Ort
         end 
         else 
            Ort = ''
         say Num Name Ort
      end /* do */
   end /* do */
end /* do */

say rc ErxGetErrorText( rc ) 

call erxClose h 
exit


TestCapi:
procedure expose NoNum ExpAll
parse arg capi

Text = ''
Info = InfoElement( capi )
do while info<>0
   len  = subword( Info, 1, 1 )
   if length( Text )>0 then Text = Text subword( Info, 2 )
                       else Text = subword( Info, 2 )
   capi = delstr( capi, 1, len )
   Info = InfoElement( capi )
end /* do */

return Text



InfoElement:
procedure expose NoNum ExpAll
parse arg Data

if length( Data )==0 then
return 0

Byte = substr( Data, 1, 1 )

if c2x( bitand( Byte, x2c( 80 ) ) )=='80' | c2x(Byte) == '01' then
do /* einzelbyte */
   rc = 0
end /* do */
else
do /* variabel */
   Len = c2d( substr( Data, 2, 1 ) ) + 2
   rc = Len VarElem( substr( Data, 1, len ) )
end /* do */
return rc

VarElem:
procedure expose NoNum ExpAll
parse arg Data

Byte = c2x( substr( Data, 1, 1 ) )
Data = substr( Data, 3 )
select 
   when Byte=='6C' then rc = '<CnPN(6C)' CnPn( Data )
otherwise
        rc = ''
end  /* select */
return rc

Display:
procedure expose NoNum ExpAll
parse arg Data

rc = ''

do while length( Data )>0
   char = c2d( substr( Data, 1, 1 ) )
   if char>31 & char<128 then
   do 
      do i=1 to length( Data )
         char = c2d( substr( Data, i, 1 ) )
         if char<32 | char>127 then leave
      end /* do */
      Text = '"'substr( Data, 1, i-1 )'"'
      Data = delstr( Data, 1, i-1 );
   end /* do */
   else
   do 
      do i=1 to length( Data )
         char = c2d( substr( Data, i, 1 ) )
         if char>31 & char<128 then leave
      end /* do */
      Text = c2x( substr( Data, 1, i-1 ) )
      Data = delstr( Data, 1, i-1 );
   end /* do */
   if rc=='' then rc = Text
             else rc = rc Text
end /* do */

return rc'>'



Redirection:
procedure expose NoNum ExpAll
parse arg Data
rc = c2x( substr( Data, 1, 2 ) )
return rc substr( Data, 3 )

Facility:
procedure expose NoNum ExpAll
parse arg Data
rc = c2x( substr( Data, 1, 2 ) )

Len = c2d( substr( Data, 3, 1 ) )

rc = rc '(Len='Len')' 

dat = substr( Data, 4, Len )

rc = rc c2x( substr( Dat, 1, 2 ) )
rc = rc c2x( substr( Dat, 3, 2 ) )
rc = rc c2x( substr( Dat, 5, 4 ) )

if len>9 then
do 
   if len>11 then
   do 
      rc = rc c2x( substr( Dat, 9, 7 ) )
      rc = rc format( c2d( substr( Dat, 16, 1 ) ), 2 )
      rc = rc c2x( substr( Dat, 17 ) )
   end /* do */
   else
   do 
      rc = rc c2x( substr( Dat, 9, len-9 ) )
   end /* do */
end /* do */

return rc || '>'

CnPN:
procedure expose NoNum ExpAll
parse arg Data
rc = c2x( substr( Data, 1, 1 ) )
if NoNum==0 then
do 
   if c2x( bitand( substr( Data, 2, 1 ), x2c( 80 ) ) )=='80' then
      rc = rc || c2x( substr( Data, 2, 1 ) ) substr( Data, 3, length( Data )-2 )'>'
   else
      rc = rc substr( Data, 2, length( Data )-1 )'>'
end /* do */
else
do 
   if c2x( bitand( substr( Data, 2, 1 ), x2c( 80 ) ) )=='80' then
      rc = rc || c2x( substr( Data, 2, 1 ) ) substr( '################################', 1, length( Data )-2 )'>'
   else
      rc = rc substr( '################################', 1, length( Data )-1 )'>'
end /* do */

return rc

CdPN:
procedure expose NoNum ExpAll
parse arg Data
if NoNum==0 then
do 
   if c2x( bitand( substr( Data, 1, 1 ), x2c( 80 ) ) )=='80' then
      rc = c2x( substr( Data, 1, 1 ) ) substr( Data, 2, length( Data )-1 )'>'
   else
      rc = substr( Data, 1, length( Data ) )'>'
end /* do */
else
do 
   if c2x( bitand( substr( Data, 1, 1 ), x2c( 80 ) ) )=='80' then
      rc = c2x( substr( Data, 1, 1 ) ) substr( '################################', 1, length( Data )-1 )'>'
   else
      rc = substr( '################################', 1, length( Data ) )'>'
end /* do */
return rc

Datum:
procedure
parse arg Data

Len = length( Data )
yy = c2d( substr( Data, 1, 1 ) )
mo = c2d( substr( Data, 2, 1 ) )
dd = c2d( substr( Data, 3, 1 ) )
hh = c2d( substr( Data, 4, 1 ) )
mi = c2d( substr( Data, 5, 1 ) )

if Len>5 then ss = ':'c2d( substr( Data, 6, 1 ) )
         else ss = ''

return dd'.'mo'.'yy hh':'mi || ss'>'


TestEura:
procedure expose LastHook
parse arg Data
len  = c2d( substr( Data, 1, 1 ) )
Data = substr( Data, 2 )

Byte = c2x( substr( Data, 1, 1 ) )
len  = c2d( substr( Data, 2, 1 ) )
select 
   when Byte=='02' then rc = '<Date(02)' Datum( substr( Data, 3, len ) )
   when Byte=='01' then rc = HookOff( substr( Data, 3, len ) )
otherwise
end  /* select */
return rc

HookOff: procedure expose LastHook
parse arg Data

rc = c2x( substr( Data, 1, 5 ) )
Data = delstr( Data, 1, 5 )
do while length( Data )>0
   rc = rc c2x( substr( Data, 1, 1 ) )
   Data = delstr( Data, 1, 1 )
end /* do */

if rc==LastHook then return ''
LastHook = rc
return '<Hook(01)' rc'>'

MsgType:
procedure
parse arg Byte
select 
   when Byte=='01' then Text = Byte'-ALERTING           '
   when Byte=='02' then Text = Byte'-CALL PROCEEDING    '
   when Byte=='03' then Text = Byte'-PROGRESS           '
   when Byte=='05' then Text = Byte'-SETUP              '
   when Byte=='07' then Text = Byte'-CONNECT            '
   when Byte=='0D' then Text = Byte'-SETUP ACKNOWLEDGE  '
   when Byte=='0F' then Text = Byte'-CONNECT KNOWLEDGE  '
   when Byte=='20' then Text = Byte'-USER INFORMATION   '
   when Byte=='21' then Text = Byte'-SUSPEND REJECT     '
   when Byte=='22' then Text = Byte'-RESUME REJECT      '
   when Byte=='25' then Text = Byte'-SUSPEND            '
   when Byte=='26' then Text = Byte'-RESUME             '
   when Byte=='2D' then Text = Byte'-SUSPEND ACKNOWLEDGE'
   when Byte=='2E' then Text = Byte'-RESUME ACKNOWLEDGE '
   when Byte=='45' then Text = Byte'-DISCONNECT         '
   when Byte=='46' then Text = Byte'-RESTART            '
   when Byte=='4D' then Text = Byte'-RELEASE            '
   when Byte=='4E' then Text = Byte'-RESTART ACKNOWLEDGE'
   when Byte=='5A' then Text = Byte'-RELEASE COMPLETE   '
   when Byte=='60' then Text = Byte'-SEGMENT            '
   when Byte=='6E' then Text = Byte'-NOTIFY             '
   when Byte=='75' then Text = Byte'-STATUS ENQUIRY     '
   when Byte=='79' then Text = Byte'-CONGESTION CONTROL '
   when Byte=='7B' then Text = Byte'-INFORMATION        '
   when Byte=='7D' then Text = Byte'-STATUS             '
   when Byte=='--' then Text =  '                       '
otherwise               Text = Byte'-<unbekannt>        '
end  /* select */
return ' 'Text

parsedata:
procedure expose NoNum ExpAll
parse arg Data

dataText = c2x( Data )

if length( data )<7 then return ''

Byte0 = c2d( substr( Data, 1, 1 ) )
Byte1 = c2d( substr( Data, 2, 1 ) ) /* mglicherweise Port      Byte1 */
Byte2 = c2x( substr( Data, 3, 1 ) )
Byte3 = c2x( substr( Data, 4, 1 ) )
Byte4 = c2x( substr( Data, 5, 1 ) )

if Byte3=='FF' then 
do 
   Line = Byte0 Byte1 Byte2 || Byte3 
   Data = DelStr( Data, 1, 5 )
   Typ = 'B'
   /* 56874 99/11/25 09:57:02 */

   select 
      when Byte4=='08' then do 
         Data = insert( x2c( 08 ), Data, 0 )
         Byte4 = '  '; 
      end /* do */
      when Byte4=='03' then do 
         Byte4 = '03'; 
      end /* do */
   otherwise return Line '<unbekannt>' '{'c2x( Data )'}'
   end  /* select */

   ProtDisc = c2x( substr( Data, 1, 1 ) )               /* Protocol discriminator? */
   if ProtDisc=='AA' | ProtDisc=='0F' then return ''

   MsgNr   = Byte4'  '

   CallRefH = substr( Data, 2, 1 )
   CallRefL = substr( Data, 3, 1 )
   Del = 3
end /* do */
else 
do 
   Line = Byte0 Byte1 Byte2 || Byte3
   Data = DelStr( Data, 1, 4 )
   Typ = 'A'

   MsgNr   = c2x( reverse( substr( Data, 1, 2 ) ) )

   ProtDisc = c2x( substr( Data, 3, 1 ) )   /* Protocol discriminator? */
   CallRefH = substr( Data, 4, 1 )
   CallRefL = substr( Data, 5, 1 )
   Del = 5
end /* do */

InOut = c2x( bitand( CallRefL, x2c( '80' ) ) )
if InOut=='00' then InOut = 'f' /* from */
               else InOut = 't' /* to */

if c2d( CallRefH )==0  then
do 
   Del = Del - 1
   CallRef = '   ' || c2x( CallRefH )
end /* do */
else
do 
   CallRefL = bitand( CallRefL, x2c( '7F' ) )
   CallRef = InOut || c2x( CallRefH ) || c2x( CallRefL )
end /* do */

Data = DelStr( Data, 1, Del )

Line = Line  MsgNr ProtDisc CallRef

MsgType = MsgType( c2x( substr( Data, 1, 1 ) ) )
Capi = TestCapi( substr( Data, 2 ) )

/* Nur Anrufer vom externen Port */
if Typ=='B' then return Capi
            else return ''


