/* liefert die Gebhrendaten - Version 0.04 (ab EuraPM2 Paket 0.25) */
/* Wenn ein Datum als Parameter angegeben wird, werden die Daten ab diesem Datum geliefert */
/* Das Datum mu im Format dd.mm.yyyy vorliegen */

call RxFuncAdd SysLoadFuncs, RexxUtil, SysLoadFuncs
call SysLoadFuncs

call RxFuncAdd 'DbRxLoadFuncs', CaTable, 'DbRxLoadFuncs' 
call DbRxLoadFuncs

call RxFuncAdd 'ErxLoadFuncs', 'EClient', 'ErxLoadFuncs' 
call ErxLoadFuncs

numeric digits 15

parse arg DateStart DateEnd

if length( DateStart )>0 then Sel = '0>='ErxGetDays( DateStart ) * 1440
                         else Sel = ''

if length( DateEnd )>0 then Sel = Sel' && 0<='ErxGetDays( DateEnd ) * 1440

/* say Sel */
rc = ErxOpenTaxDb( 'ulCount', Sel )
if rc>0 then 
do 
   say ErxGetErrorText( rc ) 'bei open'
   exit rc
end /* do */

say ulCount 'Datenstze'
ulCount = ulCount - 1

do i=0 to ulCount
   rc = ErxGetTaxDbData( i, 'Data', 'TRNVODZdGgK' )   
/*
   rc = ErxGetTaxDbData( i, 'Data', 'TtMRNVODZdSQKGgPpIi' )   
   rc = ErxGetTaxDbData( i, 'Data', 'RGgPpIi' )
   rc = ErxGetTaxDbData( i, 'Data' )
*/
   if rc==0 then
   do 
/*
      Datum = ErxSubCol( Data, 5, '; ' )    /* Spalte 8 (Datum) aus Data extrahieren */
      Datum = ErxGetDays( Datum )           /* Datum in Anzahl Tage umwandeln */
*/
      say Data
   end /* do */
   else
   do 
      say ErxGetErrorText( rc ) 'bei ErxGetTaxDbData'
      leave
   end /* do */
end /* do */

call ErxCloseTaxDb


